/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.5
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "Transat"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "Transat"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "2.0"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *detailed_help_help; /**< @brief Print help, including all details and hidden options, and exit help description.  */
  const char *full_help_help; /**< @brief Print help, including hidden options, and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * target_arg;	/**< @brief RNA multiple sequence alignment in FASTA format
.  */
  char * target_orig;	/**< @brief RNA multiple sequence alignment in FASTA format
 original value given at command line.  */
  const char *target_help; /**< @brief RNA multiple sequence alignment in FASTA format
 help description.  */
  char * tree_arg;	/**< @brief Phylogenetic tree in Newick format for the alignment
.  */
  char * tree_orig;	/**< @brief Phylogenetic tree in Newick format for the alignment
 original value given at command line.  */
  const char *tree_help; /**< @brief Phylogenetic tree in Newick format for the alignment
 help description.  */
  char * output_arg;	/**< @brief Prefix of output files
 (default='helices').  */
  char * output_orig;	/**< @brief Prefix of output files
 original value given at command line.  */
  const char *output_help; /**< @brief Prefix of output files
 help description.  */
  char * query_arg;	/**< @brief Second multiple sequence alignment, triggers interacting helix prediction
.  */
  char * query_orig;	/**< @brief Second multiple sequence alignment, triggers interacting helix prediction
 original value given at command line.  */
  const char *query_help; /**< @brief Second multiple sequence alignment, triggers interacting helix prediction
 help description.  */
  int min_stem_length_arg;	/**< @brief Minimum length of candidate helices to predict
 (default='4').  */
  char * min_stem_length_orig;	/**< @brief Minimum length of candidate helices to predict
 original value given at command line.  */
  const char *min_stem_length_help; /**< @brief Minimum length of candidate helices to predict
 help description.  */
  int min_loop_length_arg;	/**< @brief Minimum length of loops in candidate helices
 (default='2').  */
  char * min_loop_length_orig;	/**< @brief Minimum length of loops in candidate helices
 original value given at command line.  */
  const char *min_loop_length_help; /**< @brief Minimum length of loops in candidate helices
 help description.  */
  double min_p_value_arg;	/**< @brief Approximate minimum possible p-value, controls number of random trials
 (default='0.001').  */
  char * min_p_value_orig;	/**< @brief Approximate minimum possible p-value, controls number of random trials
 original value given at command line.  */
  const char *min_p_value_help; /**< @brief Approximate minimum possible p-value, controls number of random trials
 help description.  */
  int no_p_value_flag;	/**< @brief Skips p-value calcaulation, setting all p-values to 0 (extremely fast)
 (default=off).  */
  const char *no_p_value_help; /**< @brief Skips p-value calcaulation, setting all p-values to 0 (extremely fast)
 help description.  */
  int dot_bracket_flag;	/**< @brief Enables bracket structure in the output (increases output size)
 (default=off).  */
  const char *dot_bracket_help; /**< @brief Enables bracket structure in the output (increases output size)
 help description.  */
  double p_value_max_arg;	/**< @brief Does not output helices with p-values above this value.  */
  char * p_value_max_orig;	/**< @brief Does not output helices with p-values above this value original value given at command line.  */
  const char *p_value_max_help; /**< @brief Does not output helices with p-values above this value help description.  */
  double likelihood_min_arg;	/**< @brief Does not output helices with log likelihoods under this ratio.  */
  char * likelihood_min_orig;	/**< @brief Does not output helices with log likelihoods under this ratio original value given at command line.  */
  const char *likelihood_min_help; /**< @brief Does not output helices with log likelihoods under this ratio help description.  */
  char * target_codon_arg;	/**< @brief Supply a codon annotation of the input file
.  */
  char * target_codon_orig;	/**< @brief Supply a codon annotation of the input file
 original value given at command line.  */
  const char *target_codon_help; /**< @brief Supply a codon annotation of the input file
 help description.  */
  int subsample_pval_flag;	/**< @brief Reduces sampling size when calculating p-values, reducing runtime
 (default=off).  */
  const char *subsample_pval_help; /**< @brief Reduces sampling size when calculating p-values, reducing runtime
 help description.  */
  int estimate_pval_flag;	/**< @brief Reduces sampling size and estimates a null distribution for p-values
 (default=off).  */
  const char *estimate_pval_help; /**< @brief Reduces sampling size and estimates a null distribution for p-values
 help description.  */
  int mantissa_flag;	/**< @brief Uses a mantissa-based number type for probability calculations
 (default=off).  */
  const char *mantissa_help; /**< @brief Uses a mantissa-based number type for probability calculations
 help description.  */
  int no_gap_penalty_flag;	/**< @brief Removes the likelihood penalty placed on one-sided gaps
 (default=off).  */
  const char *no_gap_penalty_help; /**< @brief Removes the likelihood penalty placed on one-sided gaps
 help description.  */
  int interactions_only_flag;	/**< @brief Applicable only when target and query file are given, returns only interacting helices (default=off).  */
  const char *interactions_only_help; /**< @brief Applicable only when target and query file are given, returns only interacting helices help description.  */
  int likelihood_only_flag;	/**< @brief Prints matrix of paired likelihoods, and a list of unpaired  instead of running Transat as usual
 (default=off).  */
  const char *likelihood_only_help; /**< @brief Prints matrix of paired likelihoods, and a list of unpaired  instead of running Transat as usual
 help description.  */
  int shuffle_only_arg;	/**< @brief Shuffles alignment n times, writes files with output prefix (default='0').  */
  char * shuffle_only_orig;	/**< @brief Shuffles alignment n times, writes files with output prefix original value given at command line.  */
  const char *shuffle_only_help; /**< @brief Shuffles alignment n times, writes files with output prefix help description.  */
  char * read_helix_arg;	/**< @brief Reads in a predefined helix structure in helix format.  */
  char * read_helix_orig;	/**< @brief Reads in a predefined helix structure in helix format original value given at command line.  */
  const char *read_helix_help; /**< @brief Reads in a predefined helix structure in helix format help description.  */
  double tree_factor_arg;	/**< @brief Rescale the tree by this factor.  */
  char * tree_factor_orig;	/**< @brief Rescale the tree by this factor original value given at command line.  */
  const char *tree_factor_help; /**< @brief Rescale the tree by this factor help description.  */
  int no_cache_flag;	/**< @brief Turn off the log likelihood, trades speed for (less) memory (default=off).  */
  const char *no_cache_help; /**< @brief Turn off the log likelihood, trades speed for (less) memory help description.  */
  int verbose_flag;	/**< @brief Verbose debug output (default=off).  */
  const char *verbose_help; /**< @brief Verbose debug output help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int detailed_help_given ;	/**< @brief Whether detailed-help was given.  */
  unsigned int full_help_given ;	/**< @brief Whether full-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int target_given ;	/**< @brief Whether target was given.  */
  unsigned int tree_given ;	/**< @brief Whether tree was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int query_given ;	/**< @brief Whether query was given.  */
  unsigned int min_stem_length_given ;	/**< @brief Whether min-stem-length was given.  */
  unsigned int min_loop_length_given ;	/**< @brief Whether min-loop-length was given.  */
  unsigned int min_p_value_given ;	/**< @brief Whether min-p-value was given.  */
  unsigned int no_p_value_given ;	/**< @brief Whether no-p-value was given.  */
  unsigned int dot_bracket_given ;	/**< @brief Whether dot-bracket was given.  */
  unsigned int p_value_max_given ;	/**< @brief Whether p-value-max was given.  */
  unsigned int likelihood_min_given ;	/**< @brief Whether likelihood-min was given.  */
  unsigned int target_codon_given ;	/**< @brief Whether target-codon was given.  */
  unsigned int subsample_pval_given ;	/**< @brief Whether subsample-pval was given.  */
  unsigned int estimate_pval_given ;	/**< @brief Whether estimate-pval was given.  */
  unsigned int mantissa_given ;	/**< @brief Whether mantissa was given.  */
  unsigned int no_gap_penalty_given ;	/**< @brief Whether no-gap-penalty was given.  */
  unsigned int interactions_only_given ;	/**< @brief Whether interactions-only was given.  */
  unsigned int likelihood_only_given ;	/**< @brief Whether likelihood-only was given.  */
  unsigned int shuffle_only_given ;	/**< @brief Whether shuffle-only was given.  */
  unsigned int read_helix_given ;	/**< @brief Whether read-helix was given.  */
  unsigned int tree_factor_given ;	/**< @brief Whether tree-factor was given.  */
  unsigned int no_cache_given ;	/**< @brief Whether no-cache was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];
/** @brief all the lines making the full help output (including hidden options) */
extern const char *gengetopt_args_info_full_help[];
/** @brief all the lines making the detailed help output (including hidden options and details) */
extern const char *gengetopt_args_info_detailed_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the full help (including hidden options)
 */
void cmdline_parser_print_full_help(void);
/**
 * Print the detailed help (including hidden options and details)
 */
void cmdline_parser_print_detailed_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
